diff --git a/src/backend/storage/ipc/procarray.c b/src/backend/storage/ipc/procarray.c
index d3b94e7..fc37a1c 100644
--- a/src/backend/storage/ipc/procarray.c
+++ b/src/backend/storage/ipc/procarray.c
@@ -1299,8 +2105,8 @@ CountOtherDBBackends(Oid databaseId, int *nbackends, int *nprepared)
 
 #define XidCacheRemove(i) \
 	do { \
-		MyProc->subxids.xids[i] = MyProc->subxids.xids[MyProc->subxids.nxids - 1]; \
-		MyProc->subxids.nxids--; \
+		proc->subxids.xids[i] = proc->subxids.xids[proc->subxids.nxids - 1]; \
+		proc->subxids.nxids--; \
 	} while (0)
 
 /*
@@ -1312,7 +2118,7 @@ CountOtherDBBackends(Oid databaseId, int *nbackends, int *nprepared)
  * latestXid must be the latest XID among the group.
  */
 void
-XidCacheRemoveRunningXids(TransactionId xid,
+XidCacheRemoveRunningXids(PGPROC *proc, TransactionId xid,
 						  int nxids, const TransactionId *xids,
 						  TransactionId latestXid)
 {
@@ -1339,9 +2145,9 @@ XidCacheRemoveRunningXids(TransactionId xid,
 	{
 		TransactionId anxid = xids[i];
 
-		for (j = MyProc->subxids.nxids - 1; j >= 0; j--)
+		for (j = proc->subxids.nxids - 1; j >= 0; j--)
 		{
-			if (TransactionIdEquals(MyProc->subxids.xids[j], anxid))
+			if (TransactionIdEquals(proc->subxids.xids[j], anxid))
 			{
 				XidCacheRemove(j);
 				break;
@@ -1355,21 +2161,21 @@ XidCacheRemoveRunningXids(TransactionId xid,
 		 * error during AbortSubTransaction.  So instead of Assert, emit a
 		 * debug warning.
 		 */
-		if (j < 0 && !MyProc->subxids.overflowed)
-			elog(WARNING, "did not find subXID %u in MyProc", anxid);
+		if (j < 0 && !proc->subxids.overflowed)
+			elog(WARNING, "did not find subXID %u in proc", anxid);
 	}
 
-	for (j = MyProc->subxids.nxids - 1; j >= 0; j--)
+	for (j = proc->subxids.nxids - 1; j >= 0; j--)
 	{
-		if (TransactionIdEquals(MyProc->subxids.xids[j], xid))
+		if (TransactionIdEquals(proc->subxids.xids[j], xid))
 		{
 			XidCacheRemove(j);
 			break;
 		}
 	}
 	/* Ordinarily we should have found it, unless the cache has overflowed */
-	if (j < 0 && !MyProc->subxids.overflowed)
-		elog(WARNING, "did not find subXID %u in MyProc", xid);
+	if (j < 0 && !proc->subxids.overflowed)
+		elog(WARNING, "did not find subXID %u in proc", xid);
 
 	/* Also advance global latestCompletedXid while holding the lock */
 	if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid,
@@ -1400,3 +2206,215 @@ DisplayXidCache(void)
 }
 
 #endif   /* XIDCACHE_DEBUG */
+
+/* ----------------------------------------------
+ * 		UnobservedTransactions sub-module
+ * ----------------------------------------------
+ *
+ * All functions must be called holding ProcArrayLock.
+ */
+void
+UnobservedTransactionsAddRange(TransactionId firstXid, TransactionId lastXid)
+{
+	TransactionId xid;
+
+	xid = firstXid;
+	while(TransactionIdPrecedes(xid, lastXid))
+	{
+		UnobservedTransactionsAddXids(firstXid, 0, NULL);
+		TransactionIdAdvance(xid);
+	}
+}
+
+/*
+ * Add unobserved xids to end of UnobservedXids array
+ */
+void
+UnobservedTransactionsAddXids(TransactionId xid, int nsubxids,
+							  TransactionId *subxid)
+{
+	int   index = procArray->numUnobservedXids;
+	TransactionId *UnobservedXids;
+
+	UnobservedXids = (TransactionId *) &(procArray->procs[procArray->maxProcs]);
+
+	/*
+	 * UnobservedXids is maintained as a ascending list of xids, with no gaps.
+	 * Incoming xids are always higher than previous entries, so we just add
+	 * them directly to the end of the array.
+	 */
+	for(;;)
+	{
+		if (TransactionIdIsValid(xid))
+		{
+			/*
+			 * check to see if we have space to store more UnobservedXids
+			 */
+			if (index >= procArray->maxUnobservedXids)
+			{
+				UnobservedTransactionsDisplay(WARNING);
+				elog(FATAL, "no more room in UnobservedXids array");
+			}
+
+			/*
+			 * append xid to UnobservedXids
+			 */
+#ifdef USE_ASSERT_CHECKING
+			if (TransactionIdIsValid(UnobservedXids[index]))
+			{
+				UnobservedTransactionsDisplay(LOG);
+				elog(FATAL, "unobservedxids leak: adding xid %u onto existing entry %d",
+					 xid, UnobservedXids[index]);
+			}
+
+			if ((index > 0 && TransactionIdPrecedes(xid, UnobservedXids[index - 1])))
+			{
+				UnobservedTransactionsDisplay(LOG);
+				elog(FATAL, "UnobservedXids leak: adding xid %u out of order at index %d",
+					 xid, index);
+			}
+#endif
+
+			elog(trace_recovery(DEBUG4), "adding unobservedxid %u (numxids %d min %u max %u)",
+				 xid, procArray->numUnobservedXids,
+				 UnobservedXids[0],
+				 UnobservedXids[procArray->numUnobservedXids]);
+
+			UnobservedXids[index++] = xid;
+		}
+
+		if (nsubxids <= 0)
+			break;
+		xid = *(subxid++);
+		nsubxids--;
+	}
+
+	procArray->numUnobservedXids = index;
+}
+
+void
+UnobservedTransactionsRemoveXids(TransactionId xid, int nsubxids,
+								 TransactionId *subxids)
+{
+	int i;
+	if (TransactionIdIsValid(xid))
+		UnobservedTransactionsRemoveXid(xid);
+	for (i = 0; i < nsubxids; i++)
+		UnobservedTransactionsRemoveXid(subxids[i]);
+}
+
+/*
+ * Remove one unobserved xid from anywhere on UnobservedXids array.
+ * If xid has already been pruned away, no need to report as missing.
+ */
+static void
+UnobservedTransactionsRemoveXid(TransactionId xid)
+{
+	int 			index;
+	bool			found = false;
+	TransactionId	*UnobservedXids;
+
+	UnobservedXids = (TransactionId *) &(procArray->procs[procArray->maxProcs]);
+
+	/*
+	 * If we haven't initialised array yet, or if we've already cleared it
+	 * ignore this and get on with it. If it's missing after this it is an
+	 * ERROR if removal is requested and the value isn't present.
+	 */
+	if (procArray->numUnobservedXids == 0 ||
+		(procArray->numUnobservedXids > 0 &&
+		TransactionIdPrecedes(xid, UnobservedXids[0])))
+		return;
+
+	elog(trace_recovery(DEBUG4), "remove unobservedxid %u (numxids %d min %u max %u)",
+										xid, procArray->numUnobservedXids,
+										UnobservedXids[0],
+										UnobservedXids[procArray->numUnobservedXids]);
+
+	/*
+	 * Locate our xid, and if found shunt others sideways to close the gap.
+	 */
+	for (index = 0; index < procArray->numUnobservedXids; index++)
+	{
+		if (!found)
+		{
+			if (UnobservedXids[index] == xid)
+				found = true;
+		}
+		else
+		{
+			Assert(index > 0);
+			UnobservedXids[index - 1] = UnobservedXids[index];
+		}
+	}
+
+	if (found)
+	{
+		procArray->numUnobservedXids--;
+		UnobservedXids[procArray->numUnobservedXids] = InvalidTransactionId;
+	}
+
+	elog(trace_recovery(DEBUG4), "finished removing unobservedxid %u (numxids %d min %u max %u)",
+										xid, procArray->numUnobservedXids,
+										UnobservedXids[0],
+										UnobservedXids[procArray->numUnobservedXids]);
+}
+
+/*
+ * Clear the whole array.
+ */
+void
+UnobservedTransactionsClearXids(void)
+{
+	int 			index;
+	TransactionId	*UnobservedXids;
+
+	elog(trace_recovery(DEBUG4), "clear UnobservedXids");
+	UnobservedTransactionsDisplay(DEBUG4);
+
+	UnobservedXids = (TransactionId *) &(procArray->procs[procArray->maxProcs]);
+
+	/*
+	 * UnobservedTransactionsAddXids() asserts that array will be empty
+	 * when we add new values. so it must be zeroes here each time.
+	 * That needs to be fast and accurate, this can be slowish.
+	 */
+	for (index = 0; index < procArray->numUnobservedXids; index++)
+	{
+		UnobservedXids[index] = 0;
+	}
+
+	procArray->numUnobservedXids = 0;
+
+	/* Note that this is cleared too */
+	procArray->lastOverflowedUnobservedXid = InvalidTransactionId;
+}
+
+void
+AdvanceLastOverflowedUnobservedXid(TransactionId xid)
+{
+	if (TransactionIdPrecedes(procArray->lastOverflowedUnobservedXid, xid))
+		procArray->lastOverflowedUnobservedXid = xid;
+}
+
+void
+UnobservedTransactionsDisplay(int trace_level)
+{
+	int				index;
+	TransactionId	*UnobservedXids;
+	StringInfoData buf;
+
+	initStringInfo(&buf);
+
+	UnobservedXids = (TransactionId *) &(procArray->procs[procArray->maxProcs]);
+
+	for (index = 0; index < procArray->numUnobservedXids; index++)
+	{
+		if (TransactionIdIsValid(UnobservedXids[index]))
+			appendStringInfo(&buf, "%u ", UnobservedXids[index]);
+	}
+
+	elog(trace_level, "%d unobserved xids %s", procArray->numUnobservedXids, buf.data);
+
+	pfree(buf.data);
+}
diff --git a/src/backend/storage/ipc/sinvaladt.c b/src/backend/storage/ipc/sinvaladt.c
index aaefa27..17bc91d 100644
--- a/src/backend/storage/ipc/sinvaladt.c
+++ b/src/backend/storage/ipc/sinvaladt.c
@@ -143,6 +143,7 @@ typedef struct ProcState
 	int			nextMsgNum;		/* next message number to read */
 	bool		resetState;		/* backend needs to reset its state */
 	bool		signaled;		/* backend has been sent catchup signal */
+	bool		sendOnly;		/* backend only sends, never receives */
 
 	/*
 	 * Next LocalTransactionId to use for each idle backend slot.  We keep
@@ -249,7 +250,7 @@ CreateSharedInvalidationState(void)
  *		Initialize a new backend to operate on the sinval buffer
  */
 void
-SharedInvalBackendInit(void)
+SharedInvalBackendInit(bool sendOnly)
 {
 	int			index;
 	ProcState  *stateP = NULL;
@@ -308,6 +309,7 @@ SharedInvalBackendInit(void)
 	stateP->nextMsgNum = segP->maxMsgNum;
 	stateP->resetState = false;
 	stateP->signaled = false;
+	stateP->sendOnly = sendOnly;
 
 	LWLockRelease(SInvalWriteLock);
 
@@ -579,7 +581,9 @@ SICleanupQueue(bool callerHasWriteLock, int minFree)
 	/*
 	 * Recompute minMsgNum = minimum of all backends' nextMsgNum, identify the
 	 * furthest-back backend that needs signaling (if any), and reset any
-	 * backends that are too far back.
+	 * backends that are too far back.  Note that because we ignore sendOnly
+	 * backends here it is possible for them to keep sending messages without
+	 * a problem even when they are the only active backend.
 	 */
 	min = segP->maxMsgNum;
 	minsig = min - SIG_THRESHOLD;
@@ -591,7 +595,7 @@ SICleanupQueue(bool callerHasWriteLock, int minFree)
 		int			n = stateP->nextMsgNum;
 
 		/* Ignore if inactive or already in reset state */
-		if (stateP->procPid == 0 || stateP->resetState)
+		if (stateP->procPid == 0 || stateP->resetState || stateP->sendOnly)
 			continue;
 
 		/*
diff --git a/src/backend/storage/lmgr/lock.c b/src/backend/storage/lmgr/lock.c
index 0150d11..2219264 100644
--- a/src/backend/storage/lmgr/lock.c
+++ b/src/backend/storage/lmgr/lock.c
@@ -35,9 +35,11 @@
 #include "access/transam.h"
 #include "access/twophase.h"
 #include "access/twophase_rmgr.h"
+#include "access/xact.h"
 #include "miscadmin.h"
 #include "pg_trace.h"
 #include "pgstat.h"
+#include "storage/sinval.h"
 #include "utils/memutils.h"
 #include "utils/ps_status.h"
 #include "utils/resowner.h"
@@ -490,6 +492,15 @@ LockAcquire(const LOCKTAG *locktag,
 	if (lockmode <= 0 || lockmode > lockMethodTable->numLockModes)
 		elog(ERROR, "unrecognized lock mode: %d", lockmode);
 
+	if (RecoveryInProgress() &&
+		locktag->locktag_type == LOCKTAG_OBJECT &&
+		lockmode > AccessShareLock)
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("cannot acquire lockmode %s on database objects while recovery is in progress",
+									lockMethodTable->lockModeNames[lockmode]),
+				 errhint("Only AccessShareLock can be acquired on database objects during recovery.")));
+
 #ifdef LOCK_DEBUG
 	if (LOCK_DEBUG_ENABLED(locktag))
 		elog(LOG, "LockAcquire: lock [%u,%u] %s",
@@ -827,6 +838,54 @@ LockAcquire(const LOCKTAG *locktag,
 
 	LWLockRelease(partitionLock);
 
+	/*
+	 * We made it all the way here. We've got the lock and we've got
+	 * it for the first time in this transaction. So now it's time
+	 * to send a WAL message so that standby servers can see this event,
+	 * if its an AccessExclusiveLock on a relation.
+	 */
+	if (!RecoveryInProgress() && lockmode >= AccessExclusiveLock &&
+		locktag->locktag_type == LOCKTAG_RELATION)
+	{
+		XLogRecData		rdata;
+		xl_rel_lock		xlrec;
+		TransactionId	xid;
+
+		/*
+		 * First thing we do is ensure that a TransactionId has been
+		 * assigned to this transaction. We don't actually need the xid
+		 * but if we don't do this then RecordTransactionCommit() and
+		 * RecordTransactionAbort() will optimise away the transaction
+		 * completion record which recovery relies upon to release locks.
+		 * It's a hack, but for a corner case not worth adding code for
+		 * into the main commit path.
+		 */
+		xid = GetTopTransactionId();
+		Assert(TransactionIdIsValid(xid));
+
+		Assert(OidIsValid(locktag->locktag_field2));
+
+		START_CRIT_SECTION();
+
+		/*
+		 * Decode the locktag back to the original values, to avoid
+		 * sending lots of empty bytes with every message.  See
+		 * lock.h to check how a locktag is defined  for LOCKTAG_RELATION
+		 */
+		xlrec.xid = xid;
+		xlrec.dbOid = locktag->locktag_field1;
+		xlrec.relOid = locktag->locktag_field2;
+
+		rdata.data = (char *) (&xlrec);
+		rdata.len = sizeof(xl_rel_lock);
+		rdata.buffer = InvalidBuffer;
+		rdata.next = NULL;
+
+		(void) XLogInsert(RM_RELATION_ID, XLOG_RELATION_LOCK, &rdata);
+
+		END_CRIT_SECTION();
+	}
+
 	return LOCKACQUIRE_OK;
 }
 
diff --git a/src/backend/storage/lmgr/proc.c b/src/backend/storage/lmgr/proc.c
index 12acb7d..483d17f 100644
--- a/src/backend/storage/lmgr/proc.c
+++ b/src/backend/storage/lmgr/proc.c
@@ -364,6 +364,11 @@ InitProcessPhase2(void)
  * to the ProcArray or the sinval messaging mechanism, either.	They also
  * don't get a VXID assigned, since this is only useful when we actually
  * hold lockmgr locks.
+ *
+ * Startup process however uses locks but never waits for them in the
+ * normal backend sense. Startup process also takes part in sinval messaging
+ * as a sendOnly process, so never reads messages from sinval queue. So
+ * Startup process does have a VXID and does show up in pg_locks.
  */
 void
 InitAuxiliaryProcess(void)
@@ -453,6 +458,24 @@ InitAuxiliaryProcess(void)
 }
 
 /*
+ * Record the PID and PGPROC structures for the Startup process, for use in
+ * ProcSendSignal().  See comments there for further explanation.
+ */
+void
+PublishStartupProcessInformation(void)
+{
+	/* use volatile pointer to prevent code rearrangement */
+	volatile PROC_HDR *procglobal = ProcGlobal;
+
+	SpinLockAcquire(ProcStructLock);
+
+	procglobal->startupProc = MyProc;
+	procglobal->startupProcPid = MyProcPid;
+
+	SpinLockRelease(ProcStructLock);
+}
+
+/*
  * Check whether there are at least N free PGPROC objects.
  *
  * Note: this is designed on the assumption that N will generally be small.
@@ -1279,7 +1302,31 @@ ProcWaitForSignal(void)
 void
 ProcSendSignal(int pid)
 {
-	PGPROC	   *proc = BackendPidGetProc(pid);
+	PGPROC	   *proc = NULL;
+
+	if (RecoveryInProgress())
+	{
+		/* use volatile pointer to prevent code rearrangement */
+		volatile PROC_HDR *procglobal = ProcGlobal;
+
+		SpinLockAcquire(ProcStructLock);
+
+		/*
+		 * Check to see whether it is the Startup process we wish to signal.
+		 * This call is made by the buffer manager when it wishes to wake
+		 * up a process that has been waiting for a pin in so it can obtain a
+		 * cleanup lock using LockBufferForCleanup(). Startup is not a normal
+		 * backend, so BackendPidGetProc() will not return any pid at all.
+		 * So we remember the information for this special case.
+		 */
+		if (pid == procglobal->startupProcPid)
+			proc = procglobal->startupProc;
+
+		SpinLockRelease(ProcStructLock);
+	}
+
+	if (proc == NULL)
+		proc = BackendPidGetProc(pid);
 
 	if (proc != NULL)
 		PGSemaphoreUnlock(&proc->sem);
diff --git a/src/backend/tcop/postgres.c b/src/backend/tcop/postgres.c
index 2beb148..7e63aa1 100644
--- a/src/backend/tcop/postgres.c
+++ b/src/backend/tcop/postgres.c
@@ -2588,8 +2588,8 @@ StatementCancelHandler(SIGNAL_ARGS)
 		 * the interrupt immediately.  No point in interrupting if we're
 		 * waiting for input, however.
 		 */
-		if (ImmediateInterruptOK && InterruptHoldoffCount == 0 &&
-			CritSectionCount == 0 && !DoingCommandRead)
+		if (InterruptHoldoffCount == 0 && CritSectionCount == 0 &&
+			(DoingCommandRead || ImmediateInterruptOK))
 		{
 			/* bump holdoff count to make ProcessInterrupts() a no-op */
 			/* until we are done getting ready for it */
@@ -2670,9 +2670,49 @@ ProcessInterrupts(void)
 					(errcode(ERRCODE_QUERY_CANCELED),
 					 errmsg("canceling autovacuum task")));
 		else
+		{
+			int cancelMode = MyProc->rconflicts.cancelMode;
+
+			/*
+			 * XXXHS: We don't yet have a clean way to cancel an
+			 * idle-in-transaction session, so make it FATAL instead.
+			 */
+			if (DoingCommandRead && IsTransactionBlock() && cancelMode == ERROR)
+				cancelMode = FATAL;
+
+			switch (cancelMode)
+			{
+				case FATAL:
+						Assert(RecoveryInProgress());
+						ereport(FATAL,
+							(errcode(ERRCODE_QUERY_CANCELED),
+							 errmsg("canceling session due to conflict with recovery")));
+				case ERROR:
+						/*
+						 * We are aborting because we need to release
+						 * locks. So we need to abort out of all
+						 * subtransactions to make sure we release
+						 * all locks at whatever their level.
+						 *
+						 * XXXHS: Should we try to examine the
+						 * transaction tree and remove just enough
+						 * subxacts to remove locks? Doubt it.
+						 */
+						Assert(RecoveryInProgress());
+						AbortOutOfAnyTransaction();
+						ereport(ERROR,
+							(errcode(ERRCODE_QUERY_CANCELED),
+							 errmsg("canceling statement due to conflict with recovery")));
+						return;
+				default:
+						/* No conflict pending, so fall through */
+						break;
+			}
+
 			ereport(ERROR,
 					(errcode(ERRCODE_QUERY_CANCELED),
 					 errmsg("canceling statement due to user request")));
+		}
 	}
 	/* If we get here, do nothing (probably, QueryCancelPending was reset) */
 }
@@ -3302,12 +3342,6 @@ PostgresMain(int argc, char *argv[], const char *username)
 		 */
 		StartupXLOG();
 		on_shmem_exit(ShutdownXLOG, 0);
-
-		/*
-		 * We have to build the flat file for pg_database, but not for the
-		 * user and group tables, since we won't try to do authentication.
-		 */
-		BuildFlatFiles(true);
 	}
 
 	/*
@@ -3324,6 +3358,15 @@ PostgresMain(int argc, char *argv[], const char *username)
 #endif
 
 	/*
+	 * We have to build the flat file for pg_database, but not for the
+	 * user and group tables, since we won't try to do authentication.
+	 * We do this after PGPROCs have been initialised, since we read
+	 * database buffers to do this.
+	 */
+	if (!IsUnderPostmaster)
+		BuildFlatFiles(true);
+
+	/*
 	 * General initialization.
 	 *
 	 * NOTE: if you are tempted to add code in this vicinity, consider putting
diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index ee4ed8b..6c3fc95 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -288,10 +288,22 @@ ProcessUtility(Node *parsetree,
 									SetPGVariable("transaction_isolation",
 												  list_make1(item->arg),
 												  true);
+
 								else if (strcmp(item->defname, "transaction_read_only") == 0)
+								{
+									A_Const	   *con;
+
+									Assert(IsA(item->arg, A_Const));
+									con = (A_Const *) item->arg;
+									Assert(nodeTag(&con->val) == T_Integer);
+
+									if (!intVal(&con->val))
+										PreventCommandDuringRecovery();
+
 									SetPGVariable("transaction_read_only",
 												  list_make1(item->arg),
 												  true);
+								}
 							}
 						}
 						break;
@@ -306,6 +318,7 @@ ProcessUtility(Node *parsetree,
 						break;
 
 					case TRANS_STMT_PREPARE:
+						PreventCommandDuringRecovery();
 						if (!PrepareTransactionBlock(stmt->gid))
 						{
 							/* report unsuccessful commit in completionTag */
@@ -315,11 +328,13 @@ ProcessUtility(Node *parsetree,
 						break;
 
 					case TRANS_STMT_COMMIT_PREPARED:
+						PreventCommandDuringRecovery();
 						PreventTransactionChain(isTopLevel, "COMMIT PREPARED");
 						FinishPreparedTransaction(stmt->gid, true);
 						break;
 
 					case TRANS_STMT_ROLLBACK_PREPARED:
+						PreventCommandDuringRecovery();
 						PreventTransactionChain(isTopLevel, "ROLLBACK PREPARED");
 						FinishPreparedTransaction(stmt->gid, false);
 						break;
@@ -694,6 +709,7 @@ ProcessUtility(Node *parsetree,
 			break;
 
 		case T_GrantStmt:
+			PreventCommandDuringRecovery();
 			ExecuteGrantStmt((GrantStmt *) parsetree);
 			break;
 
@@ -866,6 +882,7 @@ ProcessUtility(Node *parsetree,
 		case T_NotifyStmt:
 			{
 				NotifyStmt *stmt = (NotifyStmt *) parsetree;
+				PreventCommandDuringRecovery();
 
 				Async_Notify(stmt->conditionname);
 			}
@@ -874,6 +891,7 @@ ProcessUtility(Node *parsetree,
 		case T_ListenStmt:
 			{
 				ListenStmt *stmt = (ListenStmt *) parsetree;
+				PreventCommandDuringRecovery();
 
 				Async_Listen(stmt->conditionname);
 			}
@@ -882,6 +900,7 @@ ProcessUtility(Node *parsetree,
 		case T_UnlistenStmt:
 			{
 				UnlistenStmt *stmt = (UnlistenStmt *) parsetree;
+				PreventCommandDuringRecovery();
 
 				if (stmt->conditionname)
 					Async_Unlisten(stmt->conditionname);
@@ -901,10 +920,12 @@ ProcessUtility(Node *parsetree,
 			break;
 
 		case T_ClusterStmt:
+			PreventCommandDuringRecovery();
 			cluster((ClusterStmt *) parsetree, isTopLevel);
 			break;
 
 		case T_VacuumStmt:
+			PreventCommandDuringRecovery();
 			vacuum((VacuumStmt *) parsetree, InvalidOid, true, NULL, false,
 				   isTopLevel);
 			break;
@@ -1022,12 +1043,14 @@ ProcessUtility(Node *parsetree,
 				ereport(ERROR,
 						(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 						 errmsg("must be superuser to do CHECKPOINT")));
+			PreventCommandDuringRecovery();
 			RequestCheckpoint(CHECKPOINT_IMMEDIATE | CHECKPOINT_FORCE | CHECKPOINT_WAIT);
 			break;
 
 		case T_ReindexStmt:
 			{
 				ReindexStmt *stmt = (ReindexStmt *) parsetree;
+				PreventCommandDuringRecovery();
 
 				switch (stmt->kind)
 				{
@@ -2522,3 +2545,12 @@ GetCommandLogLevel(Node *parsetree)
 
 	return lev;
 }
+
+void
+PreventCommandDuringRecovery(void)
+{
+	if (RecoveryInProgress())
+		ereport(ERROR,
+			(errcode(ERRCODE_READ_ONLY_SQL_TRANSACTION),
+			 errmsg("cannot be run until recovery completes")));
+}
diff --git a/src/backend/utils/adt/txid.c b/src/backend/utils/adt/txid.c
index 7e51f9e..0a4ee4b 100644
--- a/src/backend/utils/adt/txid.c
+++ b/src/backend/utils/adt/txid.c
@@ -338,6 +338,12 @@ txid_current(PG_FUNCTION_ARGS)
 	txid		val;
 	TxidEpoch	state;
 
+	if (RecoveryInProgress())
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("cannot assign txid while recovery is in progress"),
+				 errhint("only read only queries can execute during recovery")));
+
 	load_xid_epoch(&state);
 
 	val = convert_xid(GetTopTransactionId(), &state);
